fn ms_to_hms ms=
(
	ms=ms/1000 as integer
	h=ms/3600 as integer
	m=(ms-h*3600)/60 as integer
	s=(ms-h*3600-m*60)
	return (formattedPrint h format:"02i") + ":" + (formattedPrint m format:"02i") + ":" + (formattedPrint s format:"02i")
)

fn printCoronaStats = (
	local width="0"
	Titles=#(\
		"PERFORMANCE Passes total:",\
		"SCENE Primitives uniq.:",\
		"SCENE Primitives inst.:",\
		"PERFORMANCE Rays/s total:",\
		"PERFORMANCE Rays/sample:",\
		"TIMES Total:\t",\
		"TIMES Rendering:\t",\
		"PERFORMANCE Noise level:"\
	)
	
	Values=#()
	Values[1]=(formattedPrint (CoronaRenderer.CoronaFp.getStatistic(0)) format:(width+".0f"))
	Values[2]=(formattedPrint (CoronaRenderer.CoronaFp.getStatistic(1)) format:(width+".0f"))
	Values[3]=(formattedPrint (CoronaRenderer.CoronaFp.getStatistic(2)) format:(width+".0f"))
	Values[4]=(formattedPrint (CoronaRenderer.CoronaFp.getStatistic(3)) format:(width+".0f"))
	Values[5]=(formattedPrint (CoronaRenderer.CoronaFp.getStatistic(4)) format:(width+".1f"))
	Values[6]=(ms_to_hms(CoronaRenderer.CoronaFp.getStatistic(5) as integer))
	Values[7]=(ms_to_hms(CoronaRenderer.CoronaFp.getStatistic(6) as integer))
	Values[8]=(formattedPrint (CoronaRenderer.CoronaFp.getStatistic(7)) format:(width+".2f"))
		
	format "\n"
	format "--== Corona Stats - v. % ==--\n" (CoronaRenderer.CoronaFp.GetCoronaVersion())
	logsystem.logEntry(" * --== Corona Stats - v. "+(CoronaRenderer.CoronaFp.GetCoronaVersion())+" ==--") info:true
	for i = 1 to 8 do (
		format (Titles[i] + "\t\t\t" + Values[i]+"\n")
		logsystem.logEntry(" * " + Titles[i] + "\t" + Values[i]) info:true
	)
	format "\n"
)

callbacks.removeScripts id:#PrintCoronaStats
callbacks.removeScripts id:#RemovePrintCoronaStats

callbacks.addScript #postrenderFrame "printCoronaStats()" id:#PrintCoronaStats
callbacks.addScript #postrender "callbacks.removeScripts id:#PrintCoronaStats; callbacks.removeScripts id:#RemovePrintCoronaStats" id:#RemovePrintCoronaStats